Hot News:

Mit Unterstützung durch:

  Foren auf CAD.de (alle Foren)
  Lisp
  Gruppencode 1 ändern?

Antwort erstellen  Neues Thema erstellen
CAD.de Login | Logout | Profil | Profil bearbeiten | Registrieren | Voreinstellungen | Hilfe | Suchen

Anzeige:

Darstellung des Themas zum Ausdrucken. Bitte dann die Druckfunktion des Browsers verwenden. | Suche nach Beiträgen nächster neuer Beitrag | nächster älterer Beitrag
Autor Thema:   Gruppencode 1 ändern? (1544 mal gelesen)
RSt-Stahl
Mitglied



Sehen Sie sich das Profil von RSt-Stahl an!   Senden Sie eine Private Message an RSt-Stahl  Schreiben Sie einen Gästebucheintrag für RSt-Stahl

Beiträge: 79
Registriert: 08.07.2005

ACAD 2006
AMD Athlon XP +4800 X2
1,5 GB Ram
500 GB HD
ATI Radeon XT1900

erstellt am: 22. Sep. 2005 16:36    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities

Hallo Forum,
ich bin gerade dabei mir ein nützliches Tool zu erstellen das es mir erlaubt einen Bemassungstext zu überschreiben. Leider funktioniert es nicht so ganz.
also ich Zeichne eine Bemassung, ich sage mal eine Winkelbemassung. Bei dieser nun erzeugten Bemassung möchte ich via Lisp den Bemassungswert von sagen wir mal 90° auf 150 ändern. Ich gehe vor wie folgt ich speichere mittels:
(SETQ TEXT (ENTLAST))
mir das letzte Objekt ab und möchte es dann mittels
(SETQ obj (ENTGET TEXT))
weiterverarbeiten. Mit
(ASSOC 1 obj)
bekomme ich dann den "Wert" des Textes angezeigt. Nun wollte ich eigentlich mit dem Befehl:
((entmod obj) (1 . "150"))
den wert auf 150 ändern, nur funktioniert das leider nicht. Was mache ich falsch kann es sein das der GC1 geschützt ist? Gibt es vielleicht eine andere Methode um Maßtexte zu überschreiben? mit ddedit habe ich es aus Lisp heraus auch nicht geschafft... da ich das Editorfenster immer mit "Okay" bestätigen musste und ich möchte gerne eine Lösung ohne Benutzer eingaben haben. Die Bemassung ist übrigens nicht "assoziativ" also alles einzelne Elemente.

Gruß
  Thomas

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

Proxy
Ehrenmitglied
Stateless-DHCP v6-Paketfragmentierer


Sehen Sie sich das Profil von Proxy an!   Senden Sie eine Private Message an Proxy  Schreiben Sie einen Gästebucheintrag für Proxy

Beiträge: 1627
Registriert: 13.11.2003

Tastaturen, Mäuse,
Pladden, ...,
AutoCADs 200X, SWX 2kX

erstellt am: 22. Sep. 2005 17:18    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities Nur für RSt-Stahl 10 Unities + Antwort hilfreich

Code:

(defun ssmod (ss dxf val)
  (mapent '(lambda (ename) (ssmodent ename dxf val)) ss)
)
(defun mapent (fun ss / i)
  (repeat (setq i (sslength ss))
    ((lambda (proc args / ss fun i)
      (apply proc args)
    )
      fun
      (list (ssname ss (setq i (1- i))))
    )
  )
)
(defun ssmodent (ename dxf val / old)
  (if (setq old (assoc dxf (entget ename)))
    (entmod (subst (cons dxf val) old (entget ename)))
    (entmod (cons (cons dxf val) (entget ename)))
  )
)
(defun ss2el (ss / res)
  (mapent (function (lambda (en) (setq res (cons en res))))
  ss
  )
  res
)
(defun C:winkelbetrug_auf_100grad (/)
  (ssmod (ssget '((0 . "DIMENSION"))) 1 "100°")
)

Doch lieber genauer Zeichnen als sich die Wunschwerte irgendwo reinschreiben. Zweitens kann man solche "Bemassungen" als Betrug erkennen und entsprechend darauf reagieren, aber auch ich glaube noch an den Weihnachtsmann. 

------------------
MfG Proxy

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

mkl-cad
Mitglied
Technischer Zeichner


Sehen Sie sich das Profil von mkl-cad an!   Senden Sie eine Private Message an mkl-cad  Schreiben Sie einen Gästebucheintrag für mkl-cad

Beiträge: 378
Registriert: 23.07.2003

ACAD 2002
Express Tools 1-9
Architektural Desktop
Windows XP
Server Windows 2003
3 GHz Rechner
1 GB RAM
80 GB Festplatte
ATI FireGL V3100
2 17" Flachbildschirme

erstellt am: 22. Sep. 2005 17:19    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities Nur für RSt-Stahl 10 Unities + Antwort hilfreich

So:?


(setq obj (subst (cons 1 "150") (assoc 1 obj) obj )) (entmod obj)

Hab ich so mal aus einen meiner Programm rausgefischt. Hoffe das tuts.

------------------
  Martin 

Viele Grüße aus dem schönen Münsterland!

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

RSt-Stahl
Mitglied



Sehen Sie sich das Profil von RSt-Stahl an!   Senden Sie eine Private Message an RSt-Stahl  Schreiben Sie einen Gästebucheintrag für RSt-Stahl

Beiträge: 79
Registriert: 08.07.2005

ACAD 2006
AMD Athlon XP +4800 X2
1,5 GB Ram
500 GB HD
ATI Radeon XT1900

erstellt am: 22. Sep. 2005 18:29    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities

Hallo Proxy, Hallo mkl-cad,

danke für eure Antworten werde gleich mal beide Versionen testen.

@Proxy: Ich will mir ein "Vermassungstool" basteln mit dem ich aus
              Winkelbemassungen (die ich weiterführen kann), Bogenlängen 
              vermassen kann! Wir haben hier mehrere Hundertmeter lange
              Bandbrücken die im Radius gekrümmt sind, und wenn ich jedes
              einzelne Maß von Hand ändere werde ich in Jahren noch damit
              beschäftigt sein :-) Habe mir schon ein Tool gebastelt aber
              da konnte ich immer nur 1 Maß berechnen beim 2ten musste ich
              immer den Endpunt des ersten Masses anklicken und da kam es
              oft zu Problemen (Maß ging in die falsche Richtung), dies
              wird mir mit der Winkelbemaßung mit geänderten Werten nicht
              passieren. Genaues Zeichen ist bei CAD unerlässlich, von hand
              gezeichnete Zeichnungen beindruckt das wenig....

Nochmals Danke für euren schnellen Antworten
    Gruß
      Thomas

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

RSt-Stahl
Mitglied



Sehen Sie sich das Profil von RSt-Stahl an!   Senden Sie eine Private Message an RSt-Stahl  Schreiben Sie einen Gästebucheintrag für RSt-Stahl

Beiträge: 79
Registriert: 08.07.2005

ACAD 2006
AMD Athlon XP +4800 X2
1,5 GB Ram
500 GB HD
ATI Radeon XT1900

erstellt am: 22. Sep. 2005 18:43    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities

Hallo mkl-cad,

habe deinen Code Probiert leider funktiert es nicht habe auch noch ne Klammer um den gesamten ausdruck gemacht hat auch nicht funktioniert. Ich bekomme folgende Fehlermeldung:
; Fehler: no function definition: nil
Trotzdem danke für den Versuch.
Der Vorschlag von Proxy hat Prima Funktioniert! Vielen Dank!
Leider ging es nur mit assoziativ vermassung aber das ist kein beinbruch dann "sprenge" ich halt die Maßkette! Unities sind unterwegs!
   Gruß
     Thomas

[Diese Nachricht wurde von RSt-Stahl am 22. Sep. 2005 editiert.]

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

CADmium
Moderator
Maschinenbaukonstrukteur




Sehen Sie sich das Profil von CADmium an!   Senden Sie eine Private Message an CADmium  Schreiben Sie einen Gästebucheintrag für CADmium

Beiträge: 13435
Registriert: 30.11.2003

.

erstellt am: 22. Sep. 2005 20:57    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities Nur für RSt-Stahl 10 Unities + Antwort hilfreich

Zitat:
Original erstellt von RSt-Stahl:

Ich will mir ein "Vermassungstool" basteln mit dem ich aus
Winkelbemassungen (die ich weiterführen kann), Bogenlängen 
vermassen kann!

Hast du dies betreffs schon mal im "Rund um Autocadforum" gesucht? Da sollte einiges an bereits fertigen Lisplösungen zu finden sein. Zumindest der Lerneneffekt ist nicht zu unterschätzen. Einfach mal Bogenbemassung in das Suchfenster eingeben..

------------------
- Thomas -
"Bei 99% aller Probleme ist die umfassende Beschreibung des Problems bereits mehr als die Hälfte der Lösung desselben."

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

RSt-Stahl
Mitglied



Sehen Sie sich das Profil von RSt-Stahl an!   Senden Sie eine Private Message an RSt-Stahl  Schreiben Sie einen Gästebucheintrag für RSt-Stahl

Beiträge: 79
Registriert: 08.07.2005

ACAD 2006
AMD Athlon XP +4800 X2
1,5 GB Ram
500 GB HD
ATI Radeon XT1900

erstellt am: 22. Sep. 2005 23:00    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities

Hallo CADmium,
ja habe mir vorher einiges im Netz und auch hier im Forum angesehen. Es sind auch schon super Tools dabei. Das Problem ist aber da wir Stahlträger haben die mit Bohrungen versehen sind und diese im Radius (Bogen) liegen wäre eine Bemassung die über das Feature "weiter" verfügt wichtig. Leider hat nicht eines der Lisp Tools das ich gefunden habe dieses Feature. Ich habe wie erwähnt schon selbst etwas versucht aber da ich noch blutiger Anfänger bin klappt das noch nicht so wie ich es mir vorstelle... Ich habe zwar eine Weiterführung "eingebaut" nur muss ich leider immer den 2ten Punkt der ersten Vermassung wieder als ersten Punkt der 2ten Vermassung "klicken" dann den 2ten Punkt und dann wieder den Punkt an dem die Maßlinie "abgesetzt" wird und diese trieft man nicht immer so genau, so das es zu sehr unschönen da unsauberen Maßketten kommt, und dieses wollte ich vermeiden indem ich die Winkelbemassung verwende mit der Option weiter. Deren Werte ich dann durch wie Proxy sagte Schummelwerte ersetzen lasse. Nur leider funktioniert es noch nicht so recht. Der Ansatz von Proxy ist schon super nur leider bekomme ich das noch nicht so Hundertprozentig eingebaut störend ist auch noch die Tatsache das ich die Bemassung "händisch" anklicken muss bevor er das maß ändert... aber ich werde das Thema weiterverfolgen... ggf. wenn jemand Interesse hat auch den fertigen Code (sobald es funktioniert) auch hier reinstellen.
  Wünsche allen noch einen schönen Abend
      Gruß
        Thomas

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

Brischke
Moderator
CAD on demand GmbH




Sehen Sie sich das Profil von Brischke an!   Senden Sie eine Private Message an Brischke  Schreiben Sie einen Gästebucheintrag für Brischke

Beiträge: 4136
Registriert: 17.05.2001

AutoCAD 20XX, defun-tools (d-tools.eu)

erstellt am: 23. Sep. 2005 00:13    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities Nur für RSt-Stahl 10 Unities + Antwort hilfreich

Hallo Thomas,

ich habe dein Vorhaben bereits für einen Kunden realisiert.
Ein Tip: Lass den Anwender die Winkelbemaßung anpicken, von der aus weiter bemaßt werden soll. Aus den Elementdaten dieser gepickten Bemaßung bekommst du die Punkte, welche dir als Basis der zu zeichnenden Bemaßung dienen. Packst du diesen Algorithmus in eine Schleife kannst die Punkte der zuletzt erstellten Bemaßung nutzen um eine weitere hinzuzufügen.

Ich habe den mit dem Programm erzeugten Bemaßungen EED's angehangen, so dass ich diese wiederum ausfindig machen kann. Das deshalb, damit der (ebenfalls eingebaute) Reactor bei der Modifizierung einer Winkelbemaßung weiß, ob das Maß in Bogenmaß geändert werden muss oder nicht. Die Maße sind somit also assoziativ.

Bei Fragen ...

Grüße Holger

------------------
Holger Brischke
CAD on demand GmbH                              Autodesk User Group Central Europe
Individuelle Lösungen von Heute auf Morgen.              AUGCE Manager Deutschland

Jackpot on demand - Wir eröffnen den Spätsommer mit einer Verlosung!

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

RSt-Stahl
Mitglied



Sehen Sie sich das Profil von RSt-Stahl an!   Senden Sie eine Private Message an RSt-Stahl  Schreiben Sie einen Gästebucheintrag für RSt-Stahl

Beiträge: 79
Registriert: 08.07.2005

ACAD 2006
AMD Athlon XP +4800 X2
1,5 GB Ram
500 GB HD
ATI Radeon XT1900

erstellt am: 23. Sep. 2005 08:56    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities

Hallo Holger,

ich werde das mal versuchen (danke für den Tipp) wie gesagt ich bin noch Anfänger im Thema LISP. Es ist eine schöne Herausforderung anhand von "kleinen" Aufgaben diese Interessante Sprache zu lernen.
Leider weis ich nicht was du mit EED's meinst. Ich habe mir das Buch AutoCAD Objekte besorgt anhand diesem habe ich jetzt "gelernt" wie man Linien und andere Objekte anhand von DXF Codes in ihrer Dimension ändern kann. Leider konnte ich noch nicht entdecken wie ich die Werte der Bemassung ändern kann aber da hat mir ja der Proxy schon weitergeholfen. Mir wäre zwar eine einzeilige Methode lieber gewesen aber dies ist wohl leider nicht möglich. Wie gesagt auf Assoziativität wird kein Wert gelegt. Du hast erwähnt das du ein solches Tool für einen Kunden bereits erstellt hast, das ist gut evtl. könnte ich ja auch bald zum Kundenkreis zählen, denn ein solches Tool würde mir die Arbeit schon ganz schön erleichtern.
      Gruß
        Thomas

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

mkl-cad
Mitglied
Technischer Zeichner


Sehen Sie sich das Profil von mkl-cad an!   Senden Sie eine Private Message an mkl-cad  Schreiben Sie einen Gästebucheintrag für mkl-cad

Beiträge: 378
Registriert: 23.07.2003

ACAD 2002
Express Tools 1-9
Architektural Desktop
Windows XP
Server Windows 2003
3 GHz Rechner
1 GB RAM
80 GB Festplatte
ATI FireGL V3100
2 17" Flachbildschirme

erstellt am: 23. Sep. 2005 13:58    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities Nur für RSt-Stahl 10 Unities + Antwort hilfreich

Komisch, müßte aber klappen. Hier mal etwas mehr im Zusammenhang:

(defun c:test (/ )
  (princ "\n Bemassung wählen")
  (setq a (ssget ))  ;Nur ein Objekt wählen
  (setq w (getreal "\n Neuer Wert: "))
  (setq p (ssname a 0))
  (setq obj (entget p))
        (setq obj (subst (cons 1 (strcat (rtos w 2 0)"%%d")) (assoc 1 obj) obj )) (entmod obj); 0=Anzahl der Kommastellen
       
  (princ)
  )

Hier ist es noch so, das nur eine Bemaßung gewählt werden darf, Könnte noch noch umstricken das alle gewählten Bemassungen auf einmal geändert werden. Auch fehlt noch ein Filter das man nur Bemasungen wählen kann.
Hier im Bespiel ist der Winkel in Dezimal, kann natürlich auch noch geändert werden.

------------------
  Martin  

Viele Grüße aus dem schönen Münsterland!

[Diese Nachricht wurde von mkl-cad am 23. Sep. 2005 editiert.]

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

RSt-Stahl
Mitglied



Sehen Sie sich das Profil von RSt-Stahl an!   Senden Sie eine Private Message an RSt-Stahl  Schreiben Sie einen Gästebucheintrag für RSt-Stahl

Beiträge: 79
Registriert: 08.07.2005

ACAD 2006
AMD Athlon XP +4800 X2
1,5 GB Ram
500 GB HD
ATI Radeon XT1900

erstellt am: 23. Sep. 2005 14:41    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities

Hallo Martin,
ja es funktioniert! Danke für deine Lösung! Bin nun gerade dabei die "Weiter"-bemassung zu realisieren. Durch deinen Code bin ich wohl wieder dem Fertigen Code etwas näher gerückt.

Danke und einen schönen Gruß aus dem sonnigen Saarbücken
      Thomas

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

Anzeige.:

Anzeige: (Infos zum Werbeplatz >>)

Darstellung des Themas zum Ausdrucken. Bitte dann die Druckfunktion des Browsers verwenden. | Suche nach Beiträgen

nächster neuerer Beitrag | nächster älterer Beitrag
Antwort erstellen


Diesen Beitrag mit Lesezeichen versehen ... | Nach anderen Beiträgen suchen | CAD.de-Newsletter

Administrative Optionen: Beitrag schliessen | Archivieren/Bewegen | Beitrag melden!

Fragen und Anregungen: Kritik-Forum | Neues aus der Community: Community-Forum

(c)2020 CAD.de | Impressum | Datenschutz